#ifndef MONETD_H
#define MONETD_H


typedef struct connection * Connection;
extern Connection ConnectionList;

#include "db/Entity.h"
#include "query/Lib.h"
#include "general/Log.h"
#include "general/Channel.h"

extern Log PingerLog;

/***************************************************************************/
/*  Connections  */
/***************************************************************************/

extern Connection ConnectionList;

#define BUFFERLENGTH  4096
#define MAX_CLIENTS 9

struct connection {
	int fid;   /* Indicates on which connection the request came, -1 is through input window */
	Request requests;
	Channel channel;
	AttributeFormat format;
	Entity  loading_entity;
	Connection next;
};

/***************************************************************************/
/*  Function Prototypes  */
/***************************************************************************/

#ifdef MONET_PROTOTYPES

extern Boolean init_connections (int);
extern void finish_connections (void);
extern Connection create_connection (int);
extern void free_connection (Connection);
extern Connection fid2connection (int);

#else

extern Boolean init_connections ();
extern void finish_connections ();
extern Connection create_connection ();
extern void free_connection ();
extern Connection fid2connection ();

#endif


/* typedef struct request * Request; */
typedef unsigned long int RequestId;

/***************************************************************************/
/*  Function Prototypes  */
/***************************************************************************/

#ifdef MONET_PROTOTYPES

extern void init_request (void);
extern void finish_request (void);
extern void make_request (Connection, String title, RequestId, String options);
extern char * request2text (Request);
extern Boolean parse_message (Connection, String);
extern void free_request (Request);
extern Boolean load_requests (Connection, String);
extern void report_all_requests ();
extern Request id2request (Connection, RequestId);
extern char * format_result (unsigned long, Request, StatusMask);
extern Entity request2Entity (Request);
extern void return_all_results (void);
extern String Entity2text (Entity);
extern void write_out_Entitys (void);

#else

extern void init_request ();
extern void finish_request ();
extern void make_request ();
extern Request id2request ();
extern char * request2text ();
extern Boolean parse_message ();
extern void free_request ();
extern Boolean load_requests ();
extern void report_all_requests ();
extern char * format_result ();
extern Entity request2Entity ();
extern void return_all_results ();
extern String Entity2text ();
extern void write_out_Entitys ();

#endif


#endif /* _REQUEST_H_ */
