.TH MONETSH 1N "Release 0.2-Beta"
.\" $Header: //gaia/group.local/computer/monet/bin/monetsh/RCS/monetsh.man,v 1.1 1991/05/28 11:03:22 a38 Exp a38 $
.SH NAME
\fBmonetsh\fR \- Command line interface to Monet
.SH SYNOPSIS
.B monetsh
<monet options ... > 
.SH DESCRIPTION
The
.I monetsh
program provides a command line oriented user interface to the \fIMonet\fR network
mapping and monitoring system.
.PP
Monetsh supports a very simple script language for database queries
and text processing.  The idea is to provide an interface that could
be used from a command line, inside a script or used to build X
interfaces.  In addition it is designed to use existing network tools
by taking their output directly and processing it for use by monet.
.PP
A number of the features described do not work properly or well.
.SH FEATURES
One of the basic problems with script languages is that they should
be very easy to type in on the command line yet have a decent syntax for
longer programs.  These actually tend to be contradictory, leading
to wierd syntax as in 'sh' or consistent but awkward to type in lisp.
Monetsh avoids this by having a relaxed syntax for the command line but
anything nested in brackets is subject to a somewhat stronger syntax,
which is basically lisp like.
.PP
Features include, function definition, recursion, loops,
conditionals, arithmetic, pipe and database select.
.PP
The pipe command is similar to that used in the unix shell
but can be thought of as a lisp 'apply' function.  For
instance it can be used to process each entity returned
by the select command individually.
.PP
Entity information is loaded from a cache or from a server \fBmonetd(8)\fR.
If connected to the latter then status changes will be notified to
the user.
.PP
There must be a map loaded before anything can be done, a map
is a view of the entity database and is basically a list of entities.
Only one map can be loaded at a time.
.PP
For a more complete set of commands use \fBmonetsh> syntax\fR
which list all defined functions together with a help message for
each.  For general help use \fBmonetsh -exec 'help;quit'\fR.

.SH SOME COMMANDS
.TP 4
.B ls-map
lists all the maps in the map directory.
.TP 4
.B load-map <filename>
loads the map file and makes it the current map.
.TP 4
.B load-edb
Loads in an entity database file, this has the status and
topology of the networks.
.TP 4
.B discard-map
get rid of current map.
.TP 4
.B list-maps
Lists all the current maps.
.TP 4
.B select [attribute=]<pattern>
looks in current map for systems matching the pattern and
puts them in the selection list.  Attributes include
\fIcontact, title, capacity, loadin ,...\fR.
.TP 4
.B report [attribute=]<pattern>
A short report.
.TP 4
.B info [attribute=]<pattern>
A long report.
.TP 4
.B list-geometry [attribute=]<pattern>
Lists the label, position and dimensions of selected systems.
This is for use with the \fIlayout(1)\fR program.
.TP 4
.B list-links [attribute=]<pattern>
Lists which systems are linked together via an interface.
The interfaces themselves are not listed.
This is for use with the \fIlayout(1)\fR program.
.TP 4
.B help
A little introduction.
.TP 4
.B syntax
A description of all the commands.
.TP 4
.B quit
exit and 'q' work too.
.SH IMPLEMENTATION
The basic command interpreter and control structures are separate
from the monet specific stuff. This was done so that new commands
could be written in C and added very easily.

.SH POSTSCRIPT
Maps can be dumped in A3 or A4 postscript format. The file is
dumped in the current directory.  Files can also be sent straight
to a postscript printer, this is done by dumping the file and then
calling a script to actually print it.  The scripts pathname is
given by the configuration parameter \fIpostscript\_prologue\fR.
.PP
The files are printed with a title and trailor noting the
author and giving a copyright symbol.  The authors name
can be set as a configuration option.  There is also an
option for printing without the header and trailor so that
the maps can more easily be included in documentation.
.PP
There is a problem with the bounding box information.  This
is not written correctly when headers and footers are included
.TP 4
.B bbfig <name>.ps
can be used to find the correct values.
.PP
This is only required if
you are going to process the postscript with some other utility,
such as including it in a \fILaTeX\fR file.

.SH FILES
~/.monetsh - local configuration
.br
/etc/monetsh - config directory
.SH "SEE ALSO"
monet(1N), xmonet(1N), monetd(8), monetmapd(8), monetrc(5)
.SH BUGS
- Currently in its infancy, implements no text processing yet
or loops.
.br
- Syntax is awful need something much more elegant.
.br
- Select statement needs improvement.
.br
Pipe and redirection not working properly.
.SH AUTHOR
James Barr, NIKHEF-H, Amsterdam

