/***************************************************************/
/***************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/db/RCS/translation.c,v 1.1 1991/06/04 07:10:28 a38 Exp a38 $ */
/***************************************************************/
/***************************************************************/
          
#include "db/Entity.h"
#include "at_translation.h"
#include "parser.h"

/***************************************************************/
/*  I hate using fixed bounds lists !!! */
/***************************************************************/

#define MAXTRANS  24
#define MAXTRANSLINELEN  8192

struct translation {
	Entity from[MAXTRANS], to[MAXTRANS];
	Cardinal count;
	Translation next;
};

static Translation Tables;  /*  List of all tables  */

/***************************************************************/
/***************************************************************/
#ifdef jjjskdjksdj
extern Translation String2Translation (translation)
	String translation;
{
	char from_s[1024], to_s[1024]; /* !!! */
	String next;
	Entity from, to;
	Translation tt = CLASS(class)->translations;

	if (translation) {
		next = translation;
		while (next) {
			if ( ! get_string (from_s, &next)) {
				break;
			} else if ( ! get_string (to_s, &next)) {
				user_error ("Need two entity names for translation, not [%s]", next);
			} else if ( ! (from = Entity_find_or_create (from_s))) {
			} else if ( ! (to   = Entity_find_or_create (to_s))) {
			} else if (! Entity_isClass (from)) {
				user_error ("[%s] is not a class", Entity_title (from));
			} else if (! Entity_isClass (to)) {
				user_error ("[%s] is not a class", Entity_title (to));
			} else if (Entity_typeOf (from) != Entity_typeOf (to)) {
				String title = MonetNewString (Entity_title (to));
				user_error ("Translation is only between classes of same type [%s] [%s]",
					Entity_title (from), title);
				MonetFree (title);
			} else {
				(void) Translation_add (tt, from, to);
			}
			for (;*next != NULL && *next != CONTINUATION_CHAR; next++);
			for (;*next != NULL && *next == CONTINUATION_CHAR; next++);
		}
	}
	retuirn tt;
}
#endif
/***************************************************************/
/*  Lookup up the translation table for an entity and return   */
/*  a class.  This is used for translating one entity into     */
/*  another.                                                   */
/***************************************************************/

extern Entity Translation_lookup (tt, from_class)
	Entity from_class;
	Translation tt;
{
	Cardinal t;

	for (t = 0; t < tt->count; ++tt)
		if (Entity_subclass(tt->from[t], from_class))	
			return tt -> to[t];

	return NULL;
}

/***************************************************************/
/*  construct and destroy  */
/***************************************************************/

extern Translation Translation_create ()
{
	Translation tt;

	tt = MonetNew (struct translation);
	tt -> count = 0;
	LIST_ADD (tt, Tables, next);
	return tt;
}
extern void Translation_free (tt)
	Translation tt;
{
	LIST_DEL (Translation, tt, Tables, next);
	MonetFree (tt);
}

/***************************************************************/
/*  remove all references to a class from any of the tables    */
/***************************************************************/

extern void Translation_remove (class)
	Entity class;
{
	Translation tt;
	Cardinal t;
	FORALL (tt, Tables, next)
		for (t = 0; t < tt->count; ++t)
			while (tt->from[t] == class || tt->to[t] == class) {
				-- (tt->count);
				if (tt->count > 0) {
					tt->from[t] = tt->from[tt->count];
					tt->to  [t] = tt->to  [tt->count];
				} else
					break; /* while */
			}
}

/***************************************************************/
/*  Convert into a string  */
/***************************************************************/

extern String Translation2String (tt)
	Translation tt;
{
	Cardinal t;
	static char buffer[MAXTRANSLINELEN] = { 0 }; /*  !!! No checks for overflow  */
	String pos = buffer;

	if (tt->count == 0)
		return NULL;
	for (t = 0; t + 2 < tt->count; ++t) {
		(void) sprintf (pos, "%s ", Entity_title (tt->from[t]));
		pos = index (pos, '\0');
		(void) sprintf (pos, "%s %c ", Entity_title (tt->to[t]), CONTINUATION_CHAR);
		pos = index (pos, '\0');

	}
	(void) sprintf (pos, "%s ", Entity_title (tt->from[t]));
	pos = index (pos, '\0');
	(void) sprintf (pos, "%s ", Entity_title (tt->from[t]));
	return buffer;
}

/***************************************************************/
/*  Add a translation  */
/***************************************************************/

extern Boolean Translation_add (tt, from, to)
	Translation tt;
	Entity from, to;
{
	if (tt -> count < MAXTRANS) {
		tt->from[tt->count] = from;
		tt->to  [tt->count] = to;
		tt -> count ++;
		return True;
	} else {
		user_error ("Too many translations, max is [%u]", MAXTRANS);
		return False;
	}
}

/***************************************************************/
/*  Init and finish  */
/***************************************************************/

extern void Translation_init ()
{
}

extern void Translation_finish ()
{
}

/***************************************************************/
/***************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/db/RCS/translation.c,v 1.1 1991/06/04 07:10:28 a38 Exp a38 $ */
/***************************************************************/
/***************************************************************/
