#ifndef MONET_CONFIG_H
#define MONET_CONFIG_H

/***********************************************************/
/*  Alter this file for your system  */
/*  Only locally configured just now  */
/*  For more detailed configuration, alter the run time    */
/*  configuration files.  */
/***********************************************************/
/*  MONET_PROTOTYPES -  Use function prototypes in include */
/*                      files.                             */
/*  C_ETC_DIRECTORY  -  Monet etc directory, set for local */
/*                      system.  /etc/monet/ recommended.  */
/***********************************************************/

/***********************************************************/
/*  vprintf(3s) is available.                              */
/***********************************************************/

#ifdef VPRINTF
#undef VPRINTF
#endif


/***********************************************************/
/*  All system paths and directories are relative to ETC,  */
/*  unless first character is a '/'.                       */
/***********************************************************/

#ifndef C_ETC_DIRECTORY
#define C_ETC_DIRECTORY "~/monet/etc"
#endif

#ifndef C_PINGER_ADDRESS
#define C_PINGER_ADDRESS  "localhost"
#endif

/***********************************************************/
/**** Compile time configurable only ****/
/***********************************************************/

#ifndef C_MAX_MAP_DEPTH
/*  !!! Not used anymore I believe  */
#define C_MAX_MAP_DEPTH 16
#endif

/***********************************************************/
/*  Originally developed using X11R3, so need XAW_BC flag  */
/*  No longer works without X11R4, so X11R4 must be set.   */
/*  !!! Convert everything to X11R4, so that it works      */
/*  !!! X11R5 etc                                          */
/***********************************************************/

#define XAW_BC
#define X11R4


/***********************************************************/
/*  Originally thought about using various different SNMP  */
/*  libraries but as I can include the CMU stuff in this   */
/*  distribution without signing bits of paper etc, I'll   */
/*  stick with it.   In addition, it seems to compile on   */
/*  several machines with no problems at all.              */
/***********************************************************/

#define CMU_SNMP

/***********************************************************/
/*  We are using BSD4.3,  I'm not actually sure if this is */
/*  used anywhere  !!!                                     */
/***********************************************************/

#define BSD_43

#endif
