

#ifndef _GATHER_H_
#define _GATHER_H_

/*************************************/
/* !!!!  */
#include "db/Entity.h"

#include <sys/param.h> /* For MAXHOSTNAMELEN */
#include <netdb.h>

typedef enum { gather_ip_host, gather_ip_network, gather_ip_interface,
  gather_x25_host, gather_dns }  GatherSystemType;


extern int h_errno;	

/*****  For systems not supporting BSD4.3 gethostbyname  ******/
#ifdef THIS_LOT_IS_NOT_NEEDED__ABC
/*
 * Error return codes from gethostbyname() and gethostbyaddr()
 */
/*  !!! Not needed */
#define	HOST_NOT_FOUND	1 /* Authoritive Answer Host not found */
#define	TRY_AGAIN	2 /* Non-Authoritive Host not found, or SERVERFAIL */
#define	NO_RECOVERY	3 /* Non recoverable errors, FORMERR, REFUSED, NOTIMP */
#define	NO_DATA		4 /* Valid name, no data record of requested type */
#define	NO_ADDRESS	NO_DATA		/* no address, look for MX record */

static struct hostent * monet_gethostbyname(name)
	char * name;
{
	struct hostent * result;
	result = gethostbyname (name);
	if (result == NULL)
		h_errno = HOST_NOT_FOUND;
	else
		h_errno = 0;
	return result;
}

static struct hostent * monet_gethostbyaddr(addr,len,type)
	char * addr;
	int len,type;
{
	struct hostent * result;
	result = gethostbyaddr (addr,len,type);
	if (result == NULL)
		h_errno = HOST_NOT_FOUND;
	else
		h_errno = 0;
	return result;
}

#else
#define monet_gethostbyname(name) gethostbyname(name)
#define monet_gethostbyaddr(addr,len,type) gethostbyaddr(addr,len,type)
#endif   /****/

#if defined(sun) || defined(ultrix)
#define herror()  user_error("Error in gethostbyname/addr");
#endif

/* !!! */
#define MAX_GATHER_RESULTS   32
/* !!! This ought to be defined elsewhere */
#define MAX_NAME_LENGTH  MAXHOSTNAMELEN
typedef struct gather_result {
	Entity interfaceClass, systemClass;
	char interface[MAX_NAME_LENGTH], system[MAX_NAME_LENGTH];
} GatherResult;


#ifdef MONET_PROTOTYPES

extern void init_gather (void);
extern void finish_gather (void);
extern Boolean lookin_ripeWhois ();
extern void gather_generalInfo ();
extern Boolean gather_connectedSystems (); /*sys, official_name, result_data, result_count */

extern int my_system ();
extern char ** ip_network_contacts ();
extern char * ip_network_name2address ();
extern char * ip_title2label ();
extern char * getlocalhostname ();

#else
extern void init_gather ();
extern void finish_gather ();
extern Boolean lookin_ripeWhois ();
extern void gather_generalInfo ();
extern Boolean gather_connectedSystems (); /*sys, official_name, result_data, result_count */

extern int my_system ();
extern char ** ip_network_contacts ();
extern char * ip_network_name2address ();
extern char * ip_title2label ();
extern char * getlocalhostname ();

#endif /* MONET_PROTOTYPES */

#endif
