/*****************************************************************************/
/*****************************************************************************/
/*  _general/help.c  */
/*****************************************************************************/
/*  Not developed very far  !!! */
/*****************************************************************************/


#include "General.h"
#include "Help.h"
#include "Log.h"


HelpMode Help_mode = help_none;
static FILE * IdeasFile;


/*****************************************************************************/

/*****************************************************************************/

static void xmapper_command_line_usage (mode)
	HelpMode mode;
{
	printf ("xmapper   - xmapper generic network mapper and monitor program\n");
	printf ("[-config <variable> <int|string>\n");
	printf ("[-help]\n");
	printf ("[-debug]\n");
	printf ("[-ideas]\n");
	printf ("[-config_file <filename>]\n");
}

/*****************************************************************************/
/*  A list of help messages                                                  */
/*****************************************************************************/

static struct {
	String subject;
	String title;
	String message;
	String ideas;
	void (* helper) ();
} Help[] = {
	{ "save", "Save ", "", "", NULL },
	{ "load", "Load", "", "", NULL },
	{ "help", "Help Mode", "", "",NULL },
	{ "ideas", "Ideas Mode", "", "", NULL },
	{ "restart", "Restart", "", "", NULL },
	{ "redraw_maps", "Redraw All Maps", "", "", NULL },
	{ "add_system", "Create a New System", "", "", NULL },
	{ "add_type", "Create a New Class", "", "", NULL },
	{ "edit", "Edit an Object", "", "", NULL },
	{ "delete", "Delete an Object", "", "", NULL },
	{ "join", "Join two Systems", "", "", NULL },
	{ "detatch", "Detatch two joined systems", "", "", NULL },
	{ "select_super", "Select a Super Component", "", "", NULL },
	{ "make_subcomponent", "Make Subcomponents", "", "", NULL },
	{ "unmake_subcomponent", "Un Make Subcomponents", "", "", NULL },
	{ "list_subcomponents", "List Subcomponents of an System", "", "", NULL },
	{ "list_supercomponents", "List Supercomponents of a System", "", "", NULL },
	{ "free_found", "De select all the systems in the found list", "", "", NULL },
	{ "free_selection", "Un select all the currently selected objects", "", "", NULL },
	{ "update", "Update (?)", "", "", NULL },
	{ "resize", "Resize an object", "", "", NULL },
	{ "redraw", "Redraw a single Map", "", "", NULL },
	{ "straighten_lines", "Straighten the link between two systems", "", "", NULL },
	{ "grid", "Set Positioning Grid to 8x8", "", "", NULL },
	{ "no_grid", "No Positioning Grid", "", "", NULL },
	{ "big_grid", "Set Positioning Grid to 16x16", "", "", NULL },
	{ "ping_system", "Ping", "", "", NULL },
	{ "request_ping", "Ask 'pinger' to ping a system", "", "", NULL },
	{ "info_system", "List of Local Info on an object", "", "", NULL },
	{ "gather_information", "Gather information on a system", "", "", NULL },
	{ "close_map", "Close Map", "", "", NULL },
	{ "expand_map", "Expand Map", "", "", NULL },
	{ "tiny_map", "Tiny drawing of Map", "", "", NULL },
	{ "small_map", "Small drawing of Map", "", "", NULL },
	{ "normal_size_map", "Normal Sized Drawing of Map", "", "", NULL },
	{ "xmapper_command_line", "XMapper Command Line Arguments", "", "", xmapper_command_line_usage },
	{ NULL, NULL, NULL, NULL, NULL }
};



/*****************************************************************************/
/* Give Help on a subject */
/*****************************************************************************/

extern void give_help (subject, mode)
	String subject;
	HelpMode mode;
{
	int i;

	for (i = 0; Help[i].subject != NULL; i++)
		if (strcmp (subject, Help[i].subject) == 0)
			break;
	if (Help[i].subject == NULL) {
		sys_error ("Sorry no help on [%s]", subject);
		return;
	}
	switch (mode) {
	default:
		sys_error ("Unknown help mode [%d], subject [%s]", mode, subject);
		return;
	case help_temporary:
		Help_mode = help_none;
		break;
	case help_none:
		return;
	case help_ideas:
		user_inform ("IDEAS ON DEVELOPING [%s]", Help[i].title);
		user_inform ("%s", Help[i].message);
		return;
	case help_verbose:
	case help_normal:
		break;
	}
	if (Help[i].helper != NULL)
		Help[i].helper (mode);
	else {
		user_inform ("HELP ON [%s]", Help[i].title);
		user_inform ("%s", Help[i].message);
	}
	return;
}


/*****************************************************************************/
/*  Initiation  */
/*****************************************************************************/

static char IdeasFileName [1023]; /* !!! */

extern void init_helper ()
{
	char * name, buffer[1024];

	name = Config_ideas_log;
	if (*name != '/') {
		char * logdir;
		logdir = (char *) MonetFilename (Config_log_directory);
		(void) sprintf (IdeasFileName, "%s/%s", logdir, Config_ideas_log);
	} else {
		(void) strcpy (IdeasFileName, Config_ideas_log);
	}
/*
	if ((IdeasFile = fopen (name, "w")) == NULL) {
		user_error ("Couldn't open new ideas file [%s]", IdeasFileName);
	} else {
		user_inform ("Opened new ideas file [%s]", IdeasFileName);
	}
*/
}

extern void finish_helper ()
{
/*
	if (IdeasFile != NULL)
		fclose (IdeasFile);
*/
}

extern Boolean can_add_new_idea ()
{
	return IdeasFile != NULL;
}

extern void add_new_idea (idea)
	String idea;
{
	if (IdeasFile == NULL) {
		user_error ("Can't write to ideas log");
	} else {
		fprintf (IdeasFile, "New Idea at %s by (%d)\n", pretty_time_stamp, (int)getuid(), idea);
		fflush (IdeasFile);
		user_inform ("Logged new idea");
	}
}

extern void add_new_idea_box ()
{
	String idea;
	char buffer[1023]; /* !!! */
	int r;

	user_inform ("Starting editor, with Ideas File [%s]", IdeasFileName);
	(void) sprintf (buffer, "xedit -geometry 400x400+500+400 %s", IdeasFileName);
	r = system (buffer);
	if (r == 127) {
		user_error ("Couldn't execute 'xedit'");
	} else if (r != 0) {
		user_error ("xedit failed");
	} else {
		user_inform ("New Idea noted");
	}
}



/*****************************************************************************/
/*****************************************************************************/
/* help.c */
/*****************************************************************************/
/*****************************************************************************/

