.TH LIBMONET 3N "Release 0.2-Beta"
.\" $Header$
.\"
.\"
.\" $Log$
.\" 
.SH NAME
.B libmonet \-
General Library for Monet
.SH SYNOPSIS
.TP
.B "#include <monet/general/General.h>"
.TP
.B "#include <monet/general/Channel.h>"
.TP
.B "#include <monet/general/SimpleList.h>"
.TP
.B "#include <monet/general/KeyList.h>"
.TP
.B "#include <monet/general/Script.h>"
.sp
.TP
\fIcc\fR\0...\0\fB\-lmonet\fR
.SH DESCRIPTION
The \fIlibmonet\fR library contains a set of routines which implement
a set of generally useful functions.  It is designed to work with
clients using X11 or those that do not.
.TP 4
.B SimpleList
\-
for handling ordered sets.
.TP 4
.B Channel
\-
for handling communications between a server and a client.
Works over X11 or user supplied select routine.  Pseudo asyncrous.
.TP 4
.B wildmat
\-
routine for matching wildcard patterns. Should be replaced by
full regex stuff.
.TP 4
.B gather
\-
gather networking information.
.TP 4
.B draw
\-
defines a simple generic drawing library.  Postscript and
a text (for debugging) version included here.  An X11 version is
included in \fIlibxmonet(3N)\fR.
.TP 4
.B log
\-
simple logging, this really needs to be extended.
.TP 4
.B messages
\-
for sending warnings, information, errors, reports and
debugging messages to the user.
Sits over X11 or stdout.
.TP 4
.B script
\-
a simple extensible script language interpreter.
.TP 4
.B MapServer
\-
a simple remote file server for accessing map files from
a remote system.  Not really very.TP 4ecific to maps.  Deals with
naming and version numbers.  The transfer itself is done using sockets
but \fIftp(1C)\fR might be more suitable.
.TP 4
.B config
\-
provides a general configuration routine which sets up a
set of parameters from the command line and/or configuration files. In
addition queries the system for some useful parameters.
.SH BUGS
.br
\- requires X11/Intrinsics header file.
.br
\- Naming of functions is not consistent.
.br
\- Communications only works over tcp/ip.
.br
\- Should generalise the pattern matching to full regexp's.
.br
\- KeyLists do not work.
.br
\- SimpleLists are inefficient.
.br
\- The term 'fid' is used in a number of functions for what should
actually be an 'fd'.
.SH AUTHORS
James Barr, NIKHEF-H, Amsterdam
.br
Alena Lacova, NIKHEF-H, Amsterdam

