


#ifndef _SIMPLELIST_H_
#define _SIMPLELIST_H_

#include "class.h"

#define ListTemplateClass(Element) \
	METHOD(Boolean, extract, (Element)); \
	METHOD(List,		create,		(void)); \
	METHOD(void,		reset,		(void)); \
	METHOD(void,		free,		(void)); \
	METHOD(void,		insert,		(Element)); \
	METHOD(Boolean,		isEmpty,	(void)); \
	METHOD(Element,		getN,		(Cardinal)); \
	METHOD(Element,		first,		(void)); \
	METHOD(Element,		next,		(void));  \ 
	METHOD(Cardinal,	sizeOf,		(void));   \
	METHOD(Element,		second,		(void));    \
	METHOD(Boolean,		isMember,	(Element));


ListTemplateClass(Entity);
ListTemplateClass(Drawing);

/**********************************************************/
/*  Maintain a simple extendable list                     */
/**********************************************************/

typedef struct simpleList * SimpleList;
#define NULL_SIMPLELIST  NULL

/**********************************************************/
/*  Prototype for searching scanning whole list           */
/**********************************************************/

#define FOR_SIMPLELIST(o, list) for (o=first_simpleList (list); o != NULL_OBJ; o=next_simpleList (list))

/**********************************************************/
/*  Functions  */
/**********************************************************/

#ifdef MONET_PROTOTYPES

extern Boolean		extract_simpleList	(SimpleList, caddr_t);
extern SimpleList	create_simpleList	(void);
extern void		reset_simpleList	(SimpleList);
extern void		free_simpleList		(SimpleList);
extern void		insert_simpleList	(SimpleList, caddr_t);
extern Boolean		isEmpty_simpleList	(SimpleList);
extern caddr_t		getN_simpleList		(SimpleList, Cardinal);
extern caddr_t		first_simpleList	(SimpleList);
extern caddr_t		next_simpleList		(SimpleList);
extern Cardinal		sizeOf_simpleList	(SimpleList);
extern caddr_t		second_simpleList	(SimpleList);
extern Boolean		isMember_simpleList	(SimpleList, caddr_t);

#else

extern Boolean		extract_simpleList	();
extern SimpleList	create_simpleList	();
extern void		reset_simpleList	();
extern void		free_simpleList		();
extern void		insert_simpleList	();
extern Boolean		isEmpty_simpleList	();
extern caddr_t		getN_simpleList		();
extern caddr_t		first_simpleList	();
extern caddr_t		next_simpleList		();
extern Cardinal		sizeOf_simpleList	();
extern caddr_t		second_simpleList	();
extern Boolean		isMember_simpleList	();

#endif


#endif
