#ifndef MONET_DRAW_MAP_H
#define MONET_DRAW_MAP_H

#define MAP_MARGIN_SIZE 5
#ifdef MONET_PROTOTYPES

extern void	init_drawMaps			(void);
extern void	finish_drawMaps			(void);
extern void	set_showEmphasizedOnly		(Boolean state);
extern void	temporary_noDrawing		(void);
extern void	allow_drawing			(void);
extern Boolean	isDrawingAllowed		(void);
extern void	Drawing_draw			(Drawing, Map, Boolean);
extern void	Drawing_outline			(Drawing, Map, Position, Position);
extern void	Drawing_redraw			(Drawing);
extern void	Drawing_undraw			(Drawing);
extern void	Drawing_unmoved_redraw		(Drawing);
extern void	Drawing_unmoved_undraw		(Drawing);
extern void	Map_draw			(Map);
extern String	Map_draw_postscript		(Map, String);
extern void	Map_draw_text			(Map);

#else

extern void	init_drawMaps			();
extern void	finish_drawMaps			();
extern void	set_showEmphasizedOnly		();
extern void	temporary_noDrawing		();
extern void	allow_drawing			();
extern Boolean	isDrawingAllowed		();
extern void	Drawing_outline			();
extern void	Drawing_draw			();
extern void	Drawing_redraw			();
extern void	Drawing_undraw			();
extern void	Drawing_unmoved_redraw		();
extern void	Drawing_unmoved_undraw		();
extern void	Map_draw			();
extern String	Map_draw_postscript		();
extern void	Map_draw_text			();

#endif

#endif
