#ifndef MONET_MAP_STATUS_H
#define MONET_MAP_STATUS_H

#include "db/Status.h"

/* This structure contains all the actual core status data for an */
/* object as opposed to the presentation status held in 'drawing' */

/* !!! The inclusion of the monetd stuff is very recent, and is an  */
/* !!! attempt to merge these two things.  */

/* Should contain other stuff from the vobject structure */



#ifdef MONET_PROTOTYPES

extern String		parse_status		(Entity, String);
extern Capacity		get_capacity		(Entity);
extern void		set_load		(Entity, Cardinal);
extern Boolean		isPingable		(Entity);
extern Capacity		get_load_in		(Entity);
extern Capacity		get_load_out		(Entity);
extern Behaviour	get_behaviour		(Entity);
extern String		get_contact		(Entity);
extern Boolean		explore_connectedSystems(Drawing);
extern void		select_local_host	(Map);
extern Boolean		rename_entity		(Entity, String);

#else

extern String		parse_status		();
extern Capacity		get_capacity		();
extern void		set_load		();
extern Boolean		isPingable		();
extern Capacity		get_load_in		();
extern Capacity		get_load_out		();
extern Behaviour	get_behaviour		();
extern String		get_contact		();
extern Boolean		explore_connectedSystems();
extern void		select_local_host	();
extern Boolean		rename_entity		();

#endif /*MONET_PROTOTYPES */

#endif

