/***********************************************************************/
/***********************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/gather.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/***********************************************************************/
/*  This is meant to provide an interface between the mapper and       */
/*  libgather.a,  This means any external requests, system calls,      */
/*  requests to other hosts are done via this module.  Calls to other  */
/*  monet processes are handled elsewhere.                             */
/*  !!!  Currently the explore stuff is here and should be in          */
/*  !!!  libgather.                                                    */
/*  !!!  This module is really a bit of a mess.                        */
/***********************************************************************/

#include "Drawing.h"
#include "general/Gather.h"
#include "Map.h"
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/errno.h>
extern int h_errno;

/***********************************************************************/

/***********************************************************************/

static Boolean gather_connectedIPSystems (sys, official_name, result_data, result_count)
	int *result_count;
	Entity sys;
	GatherResult **result_data;
	char ** official_name;
{
	static GatherResult result [MAX_GATHER_RESULTS];
	static struct hostent  *host;

	int count = 0;
	int i, j, p[4];
	long address;
	char *a;

	PROC ("gather_connectedIPSystems");

	if (isdigit ((TITLE(sys))[0]))
		/* !!! This has not been tested */
		host = monet_gethostbyaddr (TITLE(sys), MonetStrlen (TITLE(sys)), AF_INET);
	else
		host = monet_gethostbyname (TITLE(sys));
	if (host == NULL) {
		if (h_errno == HOST_NOT_FOUND) {
			*official_name = NULL;
			return True;
		}
		herror ("");
		return False;
	} else {
		*official_name = host->h_name;
/*		for (i = 0; host->h_aliases[i] != NULL; i++) {
			   printf ("Alias [%s]\n", host->h_aliases[i]);
		}
*/
		if (host->h_addrtype != AF_INET || host->h_length != 4) {
			sys_error ("Address type [%d] length [%d]\n", host -> h_addrtype, host-> h_length);
			return False;
		}
		for (i = 0; host->h_addr_list[i] != NULL; i++) {
			if (i == MAX_GATHER_RESULTS) {
				user_inform ("Maximum number of connected systems exceeded [%d]", MAX_GATHER_RESULTS);
          			break;
          		}
			address = ntohl ( (long) host->h_addr_list[i]);
			a = (char*) address;
			for (j=0; j<4; j++) {
				if (a[j] >= 0)
					p[j] = a[j];
				else
					p[j] = (a[j] & 255);
			}
			(void) sprintf (result [count].interface, "%u.%u.%u.%u", p[0], p[1], p[2], p[3]);
			result [count].interfaceClass = Std_Type.ip_interface;
			if (IN_CLASSC(address)) {
				p[1] = 0;
				p[2] = 0;
			} else if (IN_CLASSB(address))
				p[2] = 0;
			(void) sprintf (result [count].system, "%u.%u.%u.0", p[0], p[1], p[2]);
			result [count].systemClass = Std_Type.ip_network;
			count ++;
		}
	}
	*result_count = count;
	*result_data  = result;

	return True;
}

/**************************************************************************/
/* Gather IP Networks
/**************************************************************************/

static Boolean gather_connectedIPNetworks (sys, official_name, result_data, result_count)
	int *result_count;
	Entity sys;
	GatherResult **result_data;
	char ** official_name;
{
	static GatherResult result [MAX_GATHER_RESULTS];
	static struct hostent  *host;

	int count = 0;
	int i, j, p[4];
	long address;
	char *a, *text;

  	PROC ("gather_connectedIPNetworks");

	
	  text = ip_network_name2address (TITLE(sys));
  if (text == NULL) {
     *official_name = NULL;
     return True;
  }
  *official_name = text;

  *result_count = 0;
	  return True;
}

/**************************************************************************/
/*    Gather information about connected systems */
/**************************************************************************/

static Boolean gather_connectedSystems (sys, official_name, result_data, result_count)
	int *result_count;
	Entity sys;
	GatherResult **result_data;
	char ** official_name;
{
	  Boolean okay = False;

	  PROC ("gather_connectedSystems");

	  user_inform ("!!! Currently this is only defined for IP hosts");
	  if (Entity_subclass (Std_Type.ip_host, sys->class)) {
    		okay = gather_connectedIPSystems (sys, official_name, result_data, result_count);
/*	} else if (Entity_subclass (Std_Type.ip_network, sys->class)) {
    		okay = gather_connectedIPNetworks (sys, official_name, result_data, result_count);
*/
	  } else {
		    user_error ("Don't know how to gather for [%s]", Entity_title(sys));
    		okay =  False;
	  }
	  return okay; 
}

/**************************************************************************/
/*  List the ip addresses */
/**************************************************************************/

extern void list_ipAddresses (addr_list, length)
	int length;
	char **addr_list;
{
	char **p;
	char byte[4];
	int c;
	for (c=0,p=addr_list; *p!=NULL; p++,c++) {
		bcopy (ntohl ((unsigned long int) *p), byte, 4);
		user_inform ("%d.%d.%d.%d", byte[0], byte[1], byte[2], byte[3]);
	}
	user_inform ("[%d] Network Addresses");
}


extern Boolean explore_connectedSystems (sys)
	Drawing sys;
{
	char * official_name, *title;
	GatherResult *result;
	int result_count, i;
	Drawing system, interface;
	Map map;
	Position y;
	Entity entity = ENTITY(sys);

	title = Drawing_title (sys);
	if (gather_connectedSystems (entity, &official_name, &result, &result_count) == False) {
		return False;
  	}
	if (official_name == NULL) {
		user_error ("System [%s] seems not to exist", title);
		set_reachability (V_STATUS(entity), status_invalid);
		return False;
	}
	if (NES (official_name, title)) {
		user_error ("The official name of [%s] is [%s]", title, official_name);
		/* !!! Should change the name */
	} else {
		user_inform ("Official name [%s]", official_name);
	}
	if (result_count == 0) {
		user_inform ("Could not find any connected systems");
		return False;
	}
	y = Y(sys) + 8 + HEIGHT(sys);

	map = Drawing_mapOf (sys);
	/* !!! If already exists we have to do a search for existing instance */
	/* !!! Ought to be able to do this in one operation */
	for (i = 0; i < result_count; i++) {
		user_inform ("Network [%s]", result[i].system);
		system    = Drawing_create (result[i].system, result[i].systemClass, map, X(sys), y, 0,0);
		interface = Drawing_create (result[i].interface, result[i].interfaceClass, map, X(sys), y,0,0);
		if (system == NULL) {
			user_inform ("System [%s] already exists", result[i].system);
			system    = Drawing_find (result[i].system, result[i].systemClass, map);
		} else {
			y += 6 + HEIGHT(sys);
		}
		user_inform ("Interface [%s]", result[i].interface);
		if (interface == NULL) {
			user_inform ("Interface [%s] already exists", result[i].interface);
			interface = Drawing_find (result[i].interface, result[i].interfaceClass, map);
		} else {
		}
		make_interface (ENTITY(interface), ENTITY(system));
		make_interface (ENTITY(interface), ENTITY(sys));
		place_interface (map, interface);
	}
	return True;
}

/**************************************************************************/
/*  General gather routine for picking up information on an entity and    */
/*  checking its consistency.  */
/**************************************************************************/

extern void gather_generalInfo (sys)
Entity sys;
{
	char * title;
	struct hostent * hostent;

	title = Entity_title (sys);
	if ((hostent = monet_gethostbyname (title)) == NULL) {
		switch (h_errno) {
		case HOST_NOT_FOUND:
			user_inform ("No information found in Nameserver, therefore not IP");
			/*  !!! Should I unset the ip attribute ? */
			break;
		case TRY_AGAIN:
			user_inform ("No nameserver information just now, try again later(sooner)");
			break;
		case NO_RECOVERY:
			user_inform ("Non recoverable error with nameserver query");
			break;
		case NO_DATA:
			user_inform ("Well it's a domain related entity but has no IP address");
			break;
		default:
			sys_error ("Unknown h_errno [%d]", h_errno);
		}
	} else {
		if (hostent->h_addrtype != AF_INET) {
			user_inform ("Strange this ventity.has an address type other than AF_INET [%d]", 
					hostent->h_addrtype);
		} else {
		}
		list_ipAddresses (hostent->h_addr_list, hostent->h_length);
		if (strcmp (title, hostent->h_name) != 0) {
			user_inform ("The official name of [%s] is actually [%s]", title, hostent->h_name);
			/* !!! Maybe change the systems name now */
		}
	}
	/* !!! Look in whois database */
	/* !!! Look for X.25 names */
}

/***********************************************************************/
/*  Select Local Host                                                  */
/*  !!! This is a bit simplistic in its names selection                */
/*  !!! Could select a network as a local host                         */
/***********************************************************************/

extern void select_local_host (map)
	Map map;
{
	char * name;
	Drawing o;

	if (map == NULL) {
		user_error ("No map supplied to select_local_host");
		return;
	}
	if ((name = Config_local_host) == NULL) {
		user_error ("Couldn't get local host name");
		return;
	}
	user_inform ("Local Host is [%s]", name);
	user_warning ("Be a bit careful with this because it is a bit simplistic");
	free_selection ();
	FOR_DRAWINGLIST (o, Map_elements (map)) {
		Entity e = ENTITY(o);
		if (EQS (TITLE(e), name) && isSystem (e)) {
			user_inform ("Selected local host [%s]", Entity_title (e));
			Entity_select_drawings (e);
			return;
		}
	}
	user_error ("Couldn't find local host [%s] on this map", name);
}

/***********************************************************************/
/***********************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/map/RCS/gather.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $ */
/***********************************************************************/
/***********************************************************************/


