/********************************************************************************/
/********************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/map/RCS/label.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $  */
/* $Log: label.c,v $
 * Revision 1.1  1991/06/11  11:26:10  a38
 * Initial revision
 *  */
/********************************************************************************/
/* Sets up and Returns an drawings label */
/* !!! Not really implemented yet */
/********************************************************************************/

#include "map/Drawing.h"
#include <ctype.h>

/********************************************************************************/
/*  Definitions  */
/********************************************************************************/

static LabelState  CurrentLabelState = label_short;

/***************************************************************/
/*  Get label for drawing, when map is drawn as a list  */
/***************************************************************/

extern void Drawing_reset_list_label (o)
	Drawing o;
{
	String label;
	char buffer [1024]; /* !!! */

	if (LISTBOX(o).label != NULL)
		MonetFree (LISTBOX(o).label);

	if (Drawing_isClass (o)) {
		label = (char *) Entity_simple_class_report (ENTITY(o));
	} else {
		(void) sprintf (buffer, "%s   %s",
			pretty_simple_status_report (V_STATUS(ENTITY(o))),
			Drawing_title (o));
		label = buffer;
	}
	LISTBOX(o).label  = MonetNewString   (label);
	LISTBOX(o).width  = width_of_string  (label) + 5;
	LISTBOX(o).height = height_of_string (label) + 5;
}

/********************************************************************************/
/*  Get label for drawing  */
/********************************************************************************/

extern String Drawing_reset_label (drawing)
	Drawing drawing;
{
	String label;
	Cardinal old_len, len;
	Map map = Drawing_mapOf (drawing);

	if ( !drawing) {
		sys_error ("Drawing is null");
		return NULL;
	}
/*	switch (LABEL_STATE(drawing)) {
	default:
		sys_error ("Unknown label state [%d]", LABEL_STATE(drawing));
		break;
	case label_default:
		break;
	case label_full:
		break;
	}
*/
	label = TITLE(ENTITY(drawing));
	old_len = MonetStrlen (LABEL(drawing));
	len     = MonetStrlen (label);
	if (len >= map->default_domain_len) {
		String place;
		place = label + (len - map->default_domain_len);
		if (EQS(place, map->default_domain)) {
			len -= map->default_domain_len;
		}
	}

	if (LABEL(drawing)){
		if (len > old_len) {
			/* -- Not enough space so reallocate */
			MonetFree (LABEL(drawing));
			LABEL(drawing) = MonetMalloc (len+1);
		} else {
			/* -- already enough space allocated */
		}
	} else {
		LABEL(drawing) = MonetMalloc (len+1);
	}

	(void) strncpy (LABEL(drawing), label, len);
	LABEL(drawing)[len] = '\0';

	BASE_WIDTH(drawing)  = width_of_string (LABEL(drawing));
	BASE_HEIGHT(drawing) = height_of_string (LABEL(drawing));

	return (LABEL(drawing));
}

/********************************************************************************/
/*  Set the label state  */
/********************************************************************************/

extern void set_label_state (state)
	LabelState state;
{
	CurrentLabelState = state;
}

/********************************************************************************/
/*  Reset the label of an drawing to the default */
/********************************************************************************/

extern void reset_label (o)
	Drawing o;
{
	Drawing_unmoved_undraw (o);
	if (LABEL(o) != NULL) {
		MonetFree (LABEL(o));
		LABEL(o) = NULL;
	}
	Drawing_prepare (o);
	Drawing_unmoved_redraw(o);
}

/********************************************************************************/
/*  Set the label of an drawing to 's' */
/********************************************************************************/

extern void set_label (o, s)
	Drawing o;
	String s;
{
	sys_error ("!!! Set label will not work");
	return;
/*
	Drawing_unmoved_undraw (o);
	DRAWING(o)->label = s;
	Drawing_unmoved_redraw(o);
*/
}

/********************************************************************************/
/********************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/map/RCS/label.c,v 1.1 1991/06/11 11:26:10 a38 Exp a38 $  */
/********************************************************************************/
/********************************************************************************/

