#ifndef MONET_SNMPLIB_H_
#define MONET_SNMPLIB_H_

#ifdef CMU_SNMP

/*****************************************************************************************************/
/* CMU SNMP Stuff */
/*****************************************************************************************************/

/*	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.


******************************************************************/

#include "cmusnmp/snmp.h"
#include "cmusnmp/snmp_impl.h"
#include "cmusnmp/asn1.h"
#include "cmusnmp/snmp_client.h"
#include "cmusnmp/snmp_api.h"
#include "cmusnmp/mib.h"

extern int  errno;

/*** "cmusnmp/snmp_impl.h", #defines void as 'char, to avoid problems !!! */
/*** !!! with compilers that don't support void *  ***/
#undef void  /* !!! hastle with cmusnmp */



extern int snmp_dump_packet;

typedef struct monetoid {
	Cardinal length;
	oid name [MAX_NAME_LEN];
} Oid;

extern Oid ifInOctets, ifOutOctets, ifOperStatus, ifSpeed,
		sysUpTime, ifNumber, ifLastChange;


#define IFOID(var,o)  if (var->name_length == o.length && \
	(bcmp((char *)o.name, (char*)var->name, o.length*sizeof(oid)) == 0)) {
#define ELSIFOID(var,oid) } else IFOID(var,oid)
#define ELSEOID  } else {
#define ENDOID }


#define add_oid2pdu(pdu,oid) snmp_add_null_var(pdu, oid.name, oid.length);

#define set_IfOid(oid,interface) {oid.name[oid.length-1] = interface;}
#define isOidSet(oid) (oid.length>0)

#ifdef MONET_PROTOTYPES

extern Boolean	init_snmplib (void);
extern void	finish_snmplib (void);
extern Boolean text2sysOid (char*, Oid*);

#else

extern Boolean	init_snmplib ();
extern void	finish_snmplib ();
extern Boolean text2sysOid ();

#endif


#endif /* CMU_SNMP */

#endif /* _SNMPLIB_H_ */
