/*****************************************************************************************/
/*****************************************************************************************/
/*  $Header$  */
/*****************************************************************************************/
/*  Does pinging of IP addresses.  Would like it to be clever and ping                   */
/*  the addresses to infer the hosts status.                                             */
/*  !!!  Does nothing yet.  Should do all the IP pinging, the stuff from ip.c should be  */
/*  !!!  put here and individual addresses pinged instead of just the host.              */
/*****************************************************************************************/

#include "ip.h"
#include "general/Gather.h"

/*****************************************************************************************/
/*  IP Queries  */
/*****************************************************************************************/

static QueryClass QP;

typedef struct ip_address {
	char * host;
} * IPQuery;
#define IP(m)  ((IPQuery)  SUBCLASSVALUE(m))

/*****************************************************************************************************/
/* Ping */
/*****************************************************************************************************/

static Boolean request (query)
	Query query;
{
	Entity mob = query->entity;
	VStatus status = V_STATUS(mob);
	return False;
}

/********************************************************************/
/*  Free  */
/********************************************************************/

static void free (mob)
	Query mob;
{
	MonetFree (IP(mob)->host);
	MonetFree (IP(mob));
}                           

/********************************************************************/
/*  Find  */
/********************************************************************/

static  Query find (host)
	String host;
{
	int cc;
	Query o;

	FORINSTANCES (o, QP)
		if (EQS(IP(o)->host, host))
			return o;

	return NULL;
}

/********************************************************************/
/*  Create  */
/********************************************************************/

static  SubValue create (query, host)
	String host;
	Query query;
{
	IPQuery new;
	new = MonetNew (struct ip_address);
	new -> host      = MonetNewString (host);
	return (SubValue) new;
}

/********************************************************************/
/*  Convert to text */
/********************************************************************/

static char * as_text (mob)
	Query mob;
{
	static char text [128]; /* !!! */
	(void) sprintf (text, "ip_address:%s", IP(mob)->host);
	return text;
}

/*****************************************************************************************/
/* Init and Finish */
/*****************************************************************************************/

static void finish () {}

extern QueryClass init_ip_address ()
{
	NEW_QUERYCLASS (QP, "ip_address");
	return QP;
}

/*****************************************************************************************/
/*****************************************************************************************/
/*  $Header$  */
/*****************************************************************************************/
/*****************************************************************************************/

