
#ifndef MONET_XIO_WIDGET_H
#define MONET_XIO_WIDGET_H

#include <Wc/WcCreate.h>
#include "xmonet/X11.h"
#include "xmonet/Report.h"
#include "xmonet/Draw.h"

extern Widget          toplevel;
extern XtAppContext    app_con;
extern Display         *display;

/******************************************************************************/
/*  For creating a Callback procedures  */
/******************************************************************************/

#define CALLBACK(name) \
	extern void name (widget, client_data, call_data)  \
	Widget widget; \
	XtPointer client_data; \
	XtPointer call_data; \
	{

#define ENDCB }

#define DECLARECB(name) extern void name PR((Widget, XtPointer, XtPointer));

/******************************************************************************/
/*  Register callback  */
/******************************************************************************/

#define RCALL(name, func, client) WcRegisterCallback(app_con, name, func, client)

/******************************************************************************/
/*  For creating Action procedures  */
/******************************************************************************/

#define ACTION(name, params_required) \
	static void name (widget,event,params,num_params) \
	Widget widget; \
	XEvent *event; \
	String *params; \
	Cardinal *num_params; \
	{ {

/*		if (*num_params != params_required && params_required != -1) \
			user_error ("Action requires %d parameters, %d given", params_required, *num_params); \
		else {
*/

#define ENDACT }}

#define DECLARE_ACTION(name) extern void name PR((Widget, XEvent *, String *, Cardinal *));

/******************************************************************************/
/*  Prototypes  */
/******************************************************************************/

#ifdef MONET_PROTOTYPES

extern void	Widget_get_dimensions	(Widget, Position *x,Position *y, Dimension * width, Dimension * height);
extern Widget	create_dialogWidget	(String, Widget, String);
extern Widget	create_dialogButton	(String, Widget, XtCallbackProc, XtPointer);
extern String	get_dialogWidgetValue	(Widget);
extern Widget	create_commandWidget	();
extern Widget	create_menu		(String, Widget);
extern Widget	create_menuEntryWidget	(String, Widget, XtCallbackProc, XtPointer);
extern Widget	create_menuLineWidget	(Widget);
extern Widget	create_popupBox		(String, Widget);
extern Widget	create_boxWidget	(String, Widget);
extern Widget	create_labelWidget	(String, Widget);
extern Widget	create_textWidget	(String, Cardinal, Widget);
extern void	create_messages_form	(Widget);
extern void	XMonet_EventLoop	(void);
extern Boolean	XMonet_init		(String app_class, int argc, char** argv);
extern String	DoCommandToString	(char ** argv, char ** errors);
extern String	WidgetName2value	(String);
extern Widget	WidgetName2Popup	(Widget, String);
extern String	TextWidget_set_value	(String w_name, String value);

#else

extern void	Widget_get_dimensions		();
extern Widget create_dialogWidget ();
extern Widget create_dialogButton ();
extern String get_dialogWidgetValue ();
extern Widget create_commandWidget ();
extern Widget create_menu ();
extern Widget create_menuEntryWidget ();
extern Widget create_menuLineWidget ();
extern Widget create_popupBox ();
extern Widget create_boxWidget ();
extern Widget create_labelWidget ();
extern Widget create_textWidget ();
extern void create_messages_form		();
extern void	XMonet_EventLoop		();
extern Boolean	XMonet_init			();
extern String	DoCommandToString		();
extern String	WidgetName2value		();
extern Widget	WidgetName2Popup		();
extern String	TextWidget_set_value		();

#endif

DECLARECB(DestroyWidgetCB);
DECLARECB(DestroyShellCB);
DECLARECB(DoConfirmActionCB);
DECLARECB(RegisterConfirmPopupCB);
DECLARECB(RegisterConfirmMessageCB);
DECLARECB(SetUserMessageWidgetCB);
DECLARECB(SetReportWidgetCB);
DECLARECB(PopupAtCursorCB);
DECLARECB(PopupCommandPopupCB);
DECLARECB(CreateAndPopupCB);
DECLARECB(PopupCentralCB);
DECLARECB(MonetLoadFileInWidgetCB);

#endif

