/******************************************************************/
/******************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/xio/draw.c,v 1.1 1991/06/27 18:09:52 a38 Exp a38 $ */
/******************************************************************/
/*  Draw library for X windows, extension to basic draw library   */
/*  includes limited scaling of drawings.  Would like a proper    */
/*  Zoom feature, but alas */
/*  Notice that FillRectangle needs 1 added to width and height   */
/*  to draw a width by height rectangle.                          */
/*  !!! Need to change GC's into shades  */
/******************************************************************/

#include "general/General.h"
#include "xmonet/Widget.h"

/******************************************************************/
/*  Definitions  */
/******************************************************************/

DrawLibrary DrawX11Lib = (DrawLibrary) 0;
static Scale DefaultScale;

typedef struct segment_request {
	Cardinal cursor;
	XSegment * data;
} LinesRequest;

/*  This needs some fixing  */
static struct {
	float x_scale, y_scale;
	Dimension       attachMargin;
	Display        *display;
	Window          window;
	Boolean		batch;  /*  Draw interactively, or batch requests  */
	LinesRequest	lines_gc[NUM_SHADE], lines_widegc[NUM_SHADE];
	Scale scale;
	}
	Def = {
	                2
	};

		

/**** GC's   [ font | wide/thin lines | shade ] ****/
/****          4    * 2               * NUM_SHADE  = 40 ****/
/**** Comprimise for now, just one font ****/

static LineWidth = 1;
static Scale PreviousScale, ThisScale;  /* This is used to save the previous map defaults */

struct scale {
	char name[MAXSCALENAMELEN];
	XFontStruct * font;
	float x_scale, y_scale;
	GC gc[NUM_SHADE], wide_gc[NUM_SHADE];
	Scale next;
};
#define Shade2GC(shade) Def.scale->gc[(int)shade]
#define Shade2wideGC(shade) Def.scale->wide_gc[(int)shade]

static Scale ScaleList = NULL;

#define FLUSH_REQUESTS() \
	{ int shade; \
	user_inform ("Flushing lines"); \
	for (shade = 0; shade<NUM_SHADE; shade++) { \
		XDrawSegments ( \
			Def.display, \
			Def.window, \
			Shade2GC(shade), \
			Def.lines_gc[(int)shade].data, \
			Def.lines_gc[(int)shade].cursor); \
		if (Def.lines_gc[(int)shade].cursor > 0) \
			user_inform ("Flushed %d of shade %d",  \
				(int) Def.lines_gc[(int)shade].cursor, \
				(int) shade);                           \
		Def.lines_gc[(int)shade].cursor = 0; \
		} \
	}

static void FINISH_REQUESTS()
{
	int shade;
	for (shade = 0; shade<NUM_SHADE; shade++)
		XtFree (Def.lines_gc[(int)shade].data);
}

static Cardinal MaxLines = 0;
static void INIT_REQUESTS()
{
	long requestsize;
	int shade;
	requestsize = XMaxRequestSize (display);
	MaxLines = ((requestsize - 3) / 2) / sizeof (XSegment);
	for (shade = 0; shade<NUM_SHADE; shade++) {
		Def.lines_gc[(int)shade].data = (XSegment *) XtMalloc ((requestsize - 3) / 2);
		Def.lines_gc[(int)shade].cursor = 0;
	}
}

static void DRAW_LINE(shade, xl, yl, xr, yr)
	Shade		shade;
	Position        xl, yl, xr, yr;
{
	GC gc;
	gc = Shade2GC(shade);

	if (Def.batch) {
		LinesRequest * request;
		XSegment * segment;
		request = &(Def.lines_gc[(int)shade]);
		if (request->cursor >= MaxLines) {
			XDrawSegments (Def.display, Def.window,
				gc, request->data, request->cursor);
			Def.lines_gc[(int)shade].cursor = 0;
		}
		segment = & (request -> data [request->cursor]);
		segment->x1 = xl;
		segment->x2 = xr;
		segment->y1 = yl;
		segment->y2 = yr;
		request -> cursor ++;
	} else {
		XDrawLine(Def.display, Def.window, gc, xl, yl, xr, yr);
	}
}


/*****************************************************************************/
/*  Set up the GC's for all maps, won't work for multiple display etc  */
/*  !!! Should not rely on 6x10 font existing, doesn't always work  */
/*****************************************************************************/

static void GetGCs(scale)
	Scale scale;
{
	TopLevelShellWidget w = (TopLevelShellWidget) toplevel;
	GC graygc, normgc, widegraygc, widenormgc, revgc, heavydotgc, wideheavydotgc;
	int             screen;
	XGCValues       values;
	unsigned int    mask = GCForeground | GCBackground | GCLineStyle |
	GCLineWidth | GCFillStyle | GCJoinStyle | GCCapStyle | GCFunction, fontMask;
	Pixel           background, foreground;
	int f;
	XFontStruct * font;

	PROC("GetGCs");

	/**** Set up back and foreground pixels ****/
	/* !!! Not guaranteed to work on colour or greyscale displays */
	screen = DefaultScreen(display);
/*	if (Config.reverse_video) {
		foreground = WhitePixel(display, screen);
		background = BlackPixel(display, screen);
*/
	background = BlackPixel(display, screen);
	foreground = WhitePixel(display, screen);
	/* !!! Hack */
	if (foreground == 0) {
		foreground = background;
		background = 0;
	}

	/**** Set up the GC's ****/
	values.function   = GXxor;
	values.foreground = foreground;
	values.background = background;
	font = scale->font;
	if (font == None) {
		values.font = None;
		fontMask = 0;
	} else {
		values.font = font->fid;
		fontMask = GCFont;
	}
	values.line_style = LineSolid;
	values.line_width = 1;
	values.cap_style  = CapRound;
	values.fill_style = FillSolid;
	values.join_style = JoinRound;

	if (scale->font == None) {
		values.font = None;
		fontMask = 0;
	} else {
		values.font = font->fid;
		fontMask = GCFont;
	}

	normgc = XtGetGC(w, mask | fontMask , &values);
	values.line_width = 3;
	values.cap_style  = CapNotLast;
	widenormgc = XtGetGC(w, mask | fontMask, &values);
	values.line_width = 1;

	values.background = foreground;
	values.foreground = background;
	values.cap_style  = CapRound;
	revgc = XtGetGC(w, mask, &values);
	values.tile = XmuCreateStippledPixmap(XtScreen(w),background,foreground,w->core.depth);
	values.fill_style = FillTiled;
	values.function   = GXxor;
	mask = GCTile | GCFillStyle | GCFunction | GCLineWidth | GCCapStyle | fontMask;
	graygc     = XtGetGC(w, mask, &values);
	values.line_width = 3;
	values.cap_style  = CapNotLast;
	widegraygc = XtGetGC(w, mask, &values);

	/********************************  Heavy dotted *************************/

	values.line_width = 3;
	values.tile = XmuCreateStippledPixmap(XtScreen(w),background,foreground,w->core.depth);
	values.fill_style = FillTiled;
	values.function   = GXxor;
	values.dashes = 4;
	mask = GCTile | GCFillStyle | GCFunction | GCLineWidth | GCCapStyle | GCDashList | fontMask;
	heavydotgc = XtGetGC(w, mask, &values);

	values.line_width = 4;
	wideheavydotgc = XtGetGC(w, mask, &values);


	/**** Set up the 'shade' to GC translation table ****/
	scale->gc[(int)shade_background]	= revgc;
	scale->gc[(int)shade_1]			= revgc;   /* Not used */
	scale->gc[(int)shade_grey]		= graygc;
	scale->gc[(int)shade_3]			= graygc;  /* Not used */
	scale->gc[(int)shade_dark]		= normgc;
	scale->gc[(int)shade_heavy]		= heavydotgc;
	scale->wide_gc[(int)shade_background]	= revgc;
	scale->wide_gc[(int)shade_1]		= revgc;   /* Not used */
	scale->wide_gc[(int)shade_grey]		= widegraygc;
	scale->wide_gc[(int)shade_3]		= widegraygc;  /* Not used */
	scale->wide_gc[(int)shade_dark]		= widenormgc;
	scale->wide_gc[(int)shade_heavy]	= wideheavydotgc;
}

/*****************************************************************************/
/*  Convert between scale and string  */
/*****************************************************************************/

extern Scale	String2Scale	(string)
	String string;
{
	Dimension width, height;
	Scale scale;
	XFontStruct * font;
	String name;

	if (string == NULL)
		string = "_default";

	if (EQS(string, "_default")) {
		name   = "6x10";
		width  = BASE_CHAR_WIDTH;
		height = BASE_CHAR_HEIGHT;
	} else if (EQS(string, "_tiny")) {
		name = "micro";
		width  = 1;
		height = 1;
	} else if (EQS(string, "_small")) {
		name   = "5x8";
		width  = 5;
		height = 8;
	} else if (EQS(string, "_large")) {
		name = "9x15";
		width  = 9;
		height = 15;
	} else {
		width = 0;
		name = string;
	}
	/*  Check to see if scale already exists  */
	FORALL(scale, ScaleList, next)
		if (EQS (name, scale->name))
			return scale;

	/*  Scale does not already exist, so try to find a font for it  */
	if (font = XLoadQueryFont(display, name)) {
		width  = XTextWidth(font, "T", 1);
		height = font->ascent + font->descent;
	} else {
		user_error("Cannot open [%s] font", name);
		if (width == 0)
			return NULL;
	}

	/*  Create a new Scale with the font  */
	scale = MonetNew (struct scale);
	if ( ! scale) {
		sys_error ("Could not allocate space for Scale");
		return NULL;
	}
	scale -> font = font;
	scale -> x_scale = (float) width   / BASE_CHAR_WIDTH;
	scale -> y_scale = (float) height  / BASE_CHAR_HEIGHT;
	(void) strncpy (scale->name, string, MAXSCALENAMELEN - 1);
	scale->name[MAXSCALENAMELEN-1] = NULL;
	LIST_ADD (scale, ScaleList, next);

	GetGCs (scale);

	return scale;
}

/******************************************************************/
/* Before drawing anything on a particular map, this routine must */
/* be called */
/* !!! Should use values given in table  */
/******************************************************************/

static void set_scale (x,y)
	float x,y;
{
	Scale s;

	if ( ! Def.scale)
		Def.scale = DefaultScale;
	Def.x_scale = x;
	Def.y_scale = y;
	if (Def.scale->x_scale > x || Def.scale->x_scale > y)
		Def.scale = NULL;

	FORALL (s, ScaleList, next)
		if (s->x_scale <= Def.x_scale && s->y_scale <= Def.y_scale)
			if ( (!Def.scale) || (
				s->x_scale >= Def.scale->x_scale &&
				s->y_scale >= Def.scale->y_scale))
					Def.scale = s;
	if (Def.scale == NULL) {
		Def.scale = DefaultScale;
	}
}

/*****************************************************************************/
/*  Convert between scale and string  */
/*****************************************************************************/

extern String	Scale2String	(scale)
	Scale scale;
{
	if (scale)
		return scale->name;
	else
		return "_default";
}

extern void Scale_xy (scale, x, y)
	Scale scale;
	float *x,*y;
{
	if ( ! scale)
		scale = DefaultScale;
	*x =  scale->x_scale;
	*y =  scale->y_scale;
}

/*****************************************************************/
/*  Call this before a batch of routines.  */
/*****************************************************************/

extern Boolean start_draw_X11 (net, scale, region, batch)
	Widget          net;
	Scale scale;
	Region region;
	Boolean batch;
{
	static ClipSet = False;
	PROC("start_draw_X11");

	if (XtIsRealized (net) == False)
		return False;

	if (scale == NULL)
		scale = DefaultScale;
	PreviousScale = ThisScale;
	ThisScale = scale;
	
	Def.batch   = batch;
	Def.display = XtDisplay(net);
	Def.window  = XtWindow(net);
	LineWidth = 1;
/*
	if (Config_reverse_video) {
		XSetWindowBackground (Def.display, Def.window,
				BlackPixel (Def.display, DefaultScreen(Def.display)));
		XSetWindowBorder (Def.display, Def.window,
				WhitePixel (Def.display, DefaultScreen(Def.display)));

	}
	XClearWindow(Def.display, Def.window);
*/
	Draw_start_draw (DrawX11Lib, scale->x_scale, scale->y_scale);
	if (region) {
		ClipSet = True;
		FORALL(scale, ScaleList, next) {
			Cardinal shade;
			for (shade = 0; shade < NUM_SHADE; ++ shade) {
				XSetRegion (display, scale->gc[shade]     , region);
				XSetRegion (display, scale->wide_gc[shade], region);
			}
		}
	} else if (ClipSet) {
		ClipSet = False;
		FORALL(scale, ScaleList, next) {
			Cardinal shade;
			for (shade = 0; shade < NUM_SHADE; ++ shade) {
				XSetClipMask (display, scale->gc[shade]     , None);
				XSetClipMask (display, scale->wide_gc[shade], None);
			}
		}
	}
	return True;
}

static void end_draw ()
{
	Scale scale;
	ThisScale = PreviousScale;
	if (Def.batch) {
		FLUSH_REQUESTS();
	}
}

/******************************************************************/
/*  Drawing routines  */
/******************************************************************/

static void draw_line(shade, xl, yl, xr, yr)
	Shade		shade;
	Position        xl, yl, xr, yr;
{
	DRAW_LINE (shade, xl, yl, xr, yr);
}

static void draw_percentage_line(shade, numer, denom, xl, yl, xr, yr)
	Shade		shade;
	Position        xl, yl, xr, yr;
	Cardinal numer, denom;
{
	Position x, y;  /*  The intermediate point */

	if (numer == 0)
		XDrawLine(Def.display, Def.window, Shade2GC(shade), xl, yl, xr, yr);
	else if (numer >= denom)
		XDrawLine(Def.display, Def.window, Shade2wideGC(shade), xl, yl, xr, yr);
	else {
		if (xl>xr) {
			x  = (xl-xr)*numer/denom + xr;
		} else {
			x  = (xr-xl)*numer/denom + xl;
		}
		if (yl>yr) {
			y  = (yl-yr)*numer/denom + yr;
		} else {
			y  = (yr-yl)*numer/denom + yl;
		}
		XDrawLine(Def.display, Def.window, Shade2GC(shade), xl, yl, x, y);
		XDrawLine(Def.display, Def.window, Shade2wideGC(shade), x, y, xr, yr);
	}
}


static void draw_elipse(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	XDrawArc(Def.display, Def.window, Shade2GC(shade), x, y, width, height, 0, 360 * 64);
}

static void fill_elipse(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	XFillArc(Def.display, Def.window, Shade2GC(shade), x, y, width, height, 0, 360 * 64);
}

static void draw_rectangle(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	XDrawRectangle(Def.display, Def.window, Shade2GC(shade), x, y, width, height);
}


static void draw_box(shade, x, y, width, height, xspace, yspace)
	Shade		shade;
	Position        x, y;
	Dimension       width, height, xspace, yspace;
{
	GC gc = Shade2GC(shade);

	XFillRectangle(Def.display, Def.window, gc, x, y, width+1, height+1);
	XFillRectangle(Def.display, Def.window, gc, x+xspace, y+yspace, width-2*xspace+1, height-2*yspace+1);
}



static void draw_roundedRectangle(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	GC gc = Shade2GC(shade);

	XDrawArc(Def.display, Def.window, gc, x, y, 5, height, 90 * 64, 180 * 64);
	XDrawArc(Def.display, Def.window, gc, x+width-5, y, 5, height, 270 * 64, 180 * 64);
	XDrawLine(Def.display, Def.window, gc, x+5, y, x+width-5, y);
	XDrawLine(Def.display, Def.window, gc, x+5, y+height, x+width-5, y+height);
	/* !!! This routine is not part of the standard, don't know how to work it either */
	/*XmuDrawRoundedRectangle(Def.display, Def.window, gc, x, y, width, height,width,height); */
}

static void fill_roundedRectangle(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	GC gc = Shade2GC(shade);

	XDrawArc(Def.display, Def.window, gc, x, y, 5, height, 90 * 64, 180 * 64);
	XDrawArc(Def.display, Def.window, gc, x+width-5, y, 5, height, 270 * 64, 180 * 64);
	XFillRectangle(Def.display, Def.window, gc, x+5, y, width-5+1, height+1);
	/* !!! This routine is not part of the standard, don't know how to work it either */
	/*XmuDrawRoundedRectangle(Def.display, Def.window, gc, x, y, width, height,width,height); */
}


static void fill_rectangle(shade, x, y, width, height)
	Shade		shade;
	Position        x, y;
	Dimension       width, height;
{
	XFillRectangle(Def.display, Def.window, Shade2GC(shade), x, y, width+1, height+1);
}

static void draw_string(shade, x, y, string)
	Shade		shade;
	Position        x, y;
	String          string;
{
	GC gc;
	int len;

	len = MonetStrlen (string);
	if (len == 0)
		return;
	gc = Shade2GC(shade);
	if (Def.scale->font &&
		Def.x_scale >= Def.scale ->x_scale &&
		Def.y_scale >= Def.scale ->y_scale) {

		XDrawString(Def.display, Def.window, gc, x, y, string, len);
	}
}


static void  draw_bitmap (id, x,y)
	BitmapId id;
	Position x, y;
{
}

static void  register_bitmap	(id, w,h, bits)
	BitmapId id;
	Dimension w, h;
	char * bits;
{
}

static void set_reverse ()
{
	/*  does nothing, because XOR is used  */
}

/*****************************************************************/
/* Init and finish drawing of entitys */
/*****************************************************************/

extern void init_drawX11(w)
	Widget w;
{
	PROC("init_drawX11");
	NEWDRAWLIB(DrawX11Lib);

	PreviousScale = NULL;
	ThisScale     = NULL;
	ScaleList     = NULL;
	DefaultScale = String2Scale ("_default");
	(void) String2Scale ("_tiny");
	(void) String2Scale ("_small");
	(void) String2Scale ("_large");
	(void) String2Scale ("*--6-*-40-*");
	(void) String2Scale ("*--6-*-50-*");
	(void) String2Scale ("*--6-*-60-*");
	(void) String2Scale ("*--8-*-80-*");
	(void) String2Scale ("5x8");
	(void) String2Scale ("6x9");
	(void) String2Scale ("6x10");
	(void) String2Scale ("6x12");
	(void) String2Scale ("7x13");
	(void) String2Scale ("8x13");
	(void) String2Scale ("8x16");

	INIT_REQUESTS();
}

extern void finish_drawX11()
{
	Scale scale;

	FINISH_REQUESTS();
	MonetFree (DrawX11Lib);
	DrawX11Lib = NULL;
	FORALL (scale, ScaleList, next)
		MonetFree (scale);
	ScaleList = NULL;
}


/*****************************************************************/
/*****************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/xio/draw.c,v 1.1 1991/06/27 18:09:52 a38 Exp a38 $ */
/*****************************************************************/
/*****************************************************************/

